<template>
  <div class="container">
    <div class="todo-header">
      <h1 data-cy="activity-title">Activity</h1>
      <v-btn data-cy="activity-add-button" color="#16abf8" class="btn-add" height="54" @click="getAdd()"
        ><v-icon class="text-white">mdi-plus</v-icon><span class="text-white">Tambah</span></v-btn
      >
    </div>
    <div class="dashboard-header">
      <div v-if="listActivity.length > 0">
        <v-row>
          <v-col v-for="(row, index) in listActivity" :key="index" md="3">
            <v-card class="mx-auto activity-card" elevation="2" data-cy="activity-item">
              <router-link :to="`/detail/${row.id}`" style="text-decoration: none">
                <v-card-text class="activity-body pa-0">
                  <h4 data-cy="activity-item-title">
                    {{ row.title }}
                  </h4>
                </v-card-text>
              </router-link>
              <div class="card-footer">
                <v-row>
                  <p data-cy="activity-item-date">{{ getDate(row.created_at) }}</p>
                  <v-icon color="#888" class="cursor-pointer" data-cy="activity-item-delete-button" @click="openDialog(row)"
                    >mdi-trash-can-outline</v-icon
                  >
                </v-row>
              </div>
            </v-card>
          </v-col>
        </v-row>
      </div>
      <div v-else>
        <v-row>
          <div md="12" data-cy="activity-empty-state" @click="getAdd()" class="cursor-pointer">
            <img src="@/assets/activity-empty.png" alt="activity empty state" data-cy="activity-empty-state" />
          </div>
        </v-row>
      </div>
    </div>
    <DialogDeleteActivity :is-open.sync="dialog" :data-activity="dataActivity"></DialogDeleteActivity>
    <v-dialog v-model="status" max-width="500" data-cy="modal-information" class="box-card">
      <v-card class="modal-content">
        <div class="modal-body-information">
          <v-card-text>
            <v-row>
              <div data-cy="modal-information-icon" class="icon-alert-sm"><v-icon color="#13d67c">mdi-alert-circle-outline</v-icon></div>
              <div data-cy="modal-information-title" class="fz-16"><p>Activity berhasil dihapus</p></div>
            </v-row>
          </v-card-text>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import moment from "moment";
import DialogDeleteActivity from "@/components/dialog-delete-activity.vue";
export default {
  name: "HomeView",
  components: {
    DialogDeleteActivity,
  },
  data() {
    return {
      dialog: false,
      dataActivity: {},
      dialogSucces: false,
    };
  },
  mounted() {
    this.getListActivity();
  },
  methods: {
    ...mapActions(["getListActivity", "postActivity"]),
    getAdd() {
      this.postActivity();
    },
    getDate(string) {
      return moment(string).format("DD MMMM YYYY");
    },
    openDialog(row) {
      this.dialog = true;
      this.dataActivity = row;
    },
  },
  computed: {
    ...mapGetters(["listActivity", "status"]),
  },
};
</script>
